chiark / gitweb /
setup: Preprocess the Xdefaults file before installing it.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile lesskey
137   ditz-config
138   mailrc signature muttrc
139   cgrc tigrc
140   gdbinit
141   guile
142   rcrc
143   toprc
144   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
145   pulse-daemon.conf:.pulse/daemon.conf
146   aspell.conf
147   tclshrc:.tclshrc tclshrc:.wishrc
148   lisp-init.lisp:.cmucl-init.lisp
149     lisp-init.lisp:.sbclrc
150     lisp-init.lisp:.clisprc.lisp
151     lisp-init.lisp:.eclrc
152   swank.lisp
153   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
154   dircolors colordiffrc screenrc cvsrc indent.pro"
155 [ "$xstuff" ] && dotfiles="$dotfiles
156   xinitrc xsession xmodmap vncrc vncsession
157   fonts.conf
158   stalonetrayrc
159   putty-defaults:.putty/sessions/Default%20Settings
160   mdw.session:.config/gnome-session/sessions/mdw.session
161   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
162   e-keybindings.cfg:.enlightenment/keybindings.cfg
163   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
164   e16-bindings:.e16/bindings.cfg"
165 echo "Installing dotfiles..."
166 for d in $dotfiles; do
167   target=.$d
168   case $d in
169     *:*) target=${d#*:} d=${d%%:*};;
170   esac
171   ft=$HOME$sub/$target
172   dir=${ft%/*}
173   mkdir -p $dir
174   ln -s $here/dot/$d $ft.new
175   mv $ft.new $ft
176   echo "  $target"
177 done
178 echo "  all done."
179
180 ## CPP-hack files which need it.
181 cppfiles=""
182 [ "$xstuff" ] && cppfiles="$cppfiles
183   Xdefaults"
184 echo "Hacking files with C preprocessor..."
185 for c in $cppfiles; do
186   target=.$c
187   case $c in
188     *:*) target=${c#*:} c=${c%%:*};;
189   esac
190   ft=$HOME$sub/$target
191   dir=${ft%/*}
192   mkdir -p $dir
193   cpp dot/$c -o $ft.new
194   mv $ft.new $ft
195   echo "  $target"
196 done
197 echo "  all done."
198
199 ## Substitute things which need substituting.
200 dotfilessubst="
201   gitconfig
202   mykermrc
203   pulse-default.pa.in:.pulse/default.pa"
204 echo "Installing dotfiles with substitutions..."
205 for d in $dotfilessubst; do
206   case $d in
207     *:*) target=${d#*:} d=${d%%:*};;
208     *) target=.$d d=$d.in;;
209   esac
210   ft=$HOME$sub/$target
211   dir=${ft%/*}
212   mkdir -p $dir
213   sed "
214 1i\\
215 ### generated by $here/setup; do not edit!\\
216
217 /@home@/ s\a\a$HOME\ag
218 /@profile@/ s\a\a$here\ag
219 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
220 " dot/$d >$ft.new
221   mv $ft.new $ft
222   echo "  $target"
223 done
224 echo "  all done."
225
226 ## Symlink backgrounds.
227 backgrounds="
228   bsg-supper.jpg
229   harley-quinn.jpg
230   hypatia.jpg
231   jue-peek.jpg
232   lilith.jpg
233   lovelace.jpg
234   medusa.jpg
235   noodly.jpg
236   rayne.jpg
237 "
238 if [ "$xstuff" ]; then
239   echo "Installing backgrounds..."
240   for b in $backgrounds; do
241     for e in enlightenment e16; do
242       dir=$HOME$sub/.$e/backgrounds
243       t=$dir/$b
244       mkdir -p $dir
245       ln -s $here/bg/$b $t.new
246       mv $t.new $t
247     done
248     echo "  $b"
249   done
250   echo "        all done."
251 fi
252
253 ###--------------------------------------------------------------------------
254 ### Install useful scripts included in this package.
255
256 scripts="
257   mdw-editor
258   mdw-pager
259   mdw-conf
260   mdw-build
261   emacsclient-hack
262   movemail-hack
263   sendmail-hack
264   aspell-hack
265   emerge-hack
266   lesspipe.sh
267   run-with-shell-env
268   start-ssh-agent
269   start-ssh-pageant
270   svnwrap
271   guest-console
272   hyperspec"
273 [ "$xstuff" ] && scripts="$scripts
274   xinitcmd
275   un-backslashify-selection
276   lock-screen
277   xpra-start-xdummy
278   xshutdown"
279 echo "Installing scripts..."
280 mkdir -p $HOME$sub/bin
281 for s in $scripts; do
282   ft=$HOME$sub/bin/$s
283   ln -s $here/bin/$s $ft.new
284   mv $ft.new $ft
285   echo "  $s"
286 done
287 echo "  all done."
288
289 hacks="
290   ssh:ssh"
291 echo "Installing hacks..."
292 for h in $hacks; do
293   d=${h%%:*} h=${h#*:}
294   ft=$HOME$sub/bin/hacks/$d
295   mkdir -p $ft
296   ln -s $here/hacks/$h $ft/$h.new
297   mv $ft/$h.new $ft/$h
298   echo "  $d:$h"
299 done
300 echo "  all done."
301
302 ###--------------------------------------------------------------------------
303 ### Set up the Emacs config.
304
305 $echon "Finding a suitable emacs:$echoc"
306 emacs=no
307 for i in emacs22 emacs23 emacs21 emacs; do
308   if type -p >/dev/null $i; then
309     emacs=$i
310     break
311   fi
312 done
313 if [ $emacs = no ]; then
314   echo " failed."
315   emacs=:
316 else
317   echo " $emacs."
318 fi
319
320 echo "Installing Emacs packages..."
321 emacspkg="
322   make-regexp
323   ew-hols
324   mdw-gnus-patch
325   git git-blame vc-git stgit
326   mdw-multiple-cursors
327   quilt"
328 for elib in $emacspkg; do
329   $echon "  $elib:$echoc"
330   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
331        (progn
332          (setq load-path (nconc load-path (list "~/lib/emacs")))
333          (kill-emacs (condition-case nil
334                          (progn (load-library "'"$elib"'") 0)
335                        (error 1))))'; then
336     echo " already installed."
337   else
338     if [ -f el/$elib.el ]; then
339       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
340     else
341       $echon " downloading$echoc"
342       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
343     fi
344     $echon " compiling$echoc"
345     (cd $HOME$sub/lib/emacs;
346       $emacs >/dev/null 2>&1 --no-site-file --batch \
347         --eval '(byte-compile-file "'"$elib.el"'")')
348     echo " done."
349   fi
350 done
351 echo "  all done."
352
353 $echon "Setting up Emacs configuration:$echoc"
354 $echon " linking$echoc"
355 for f in dot-emacs.el Makefile; do
356   set -- $(echo $link | tr : ' ')
357   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
358   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
359 done
360 $echon " compiling$echoc"
361 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
362 echo " done."
363
364 ###----- That's all, folks --------------------------------------------------